! Используя ряд Тейлора, посчитать arcsin(x)
! Контрольная №1, Кремер Илья | http://kremer.pro/blog/?post_type=post&p=35

program main
	implicit none
	include "omp_lib.h"

	integer, parameter :: N_MAX = 10000000 ! 10M
	double precision, parameter :: X = 1
	double precision, parameter :: EPS = 0.00025 ! Увеличить, чтобы использовать меньшее количество слагаемых
	integer i
	double precision arcsin, true_arcsin
	double precision m, prev, tmp
	double precision start_time

	start_time = omp_get_wtime()
	arcsin = X
	true_arcsin = asin(X)
	prev = X
	do i = 0, N_MAX - 1
		m = ((2*i + 2) + 0.0) / (4 * (i + 1))
		m = (m * (2 * i + 1)) / (i + 1)
		m = (m * (2*i + 1) * X * X) / (2*i + 3)
		tmp = prev * m
		arcsin = arcsin + tmp
		if (true_arcsin - arcsin <= EPS) exit
		prev = tmp
	enddo

	print '(/, f8.5, 4x, a, /)', omp_get_wtime() - start_time, "секунд затрачено"
	print '(i8, 4x, a)', i + 1, "слагаемых использовано"
	print 10, arcsin, "подсчитанный", true_arcsin, "истинный"
10	format (f12.8, 4x, a, /f12.8, 4x, a)
end program
