! Используя ряд Тейлора, посчитать arcsin(x)
! Контрольная №1, Кремер Илья | http://kremer.pro/blog/?post_type=post&p=35

program main
	implicit none
	include "omp_lib.h"

	integer, parameter :: N_MAX = 5100000 ! 10M
	double precision, parameter :: X = 1
	double precision, parameter :: EPS = 0.00025 ! Увеличить, чтобы использовать меньшее количество слагаемых
	double precision, allocatable, dimension(:) :: m ! static array -> crash
	integer i
	double precision arcsin, prev, tmp, true_arcsin
	double precision start_time

	start_time = omp_get_wtime()
	allocate(m(N_MAX))
!$omp parallel num_threads(8) shared(m)
!$omp do schedule(guided, 1000)
	do i = 0, N_MAX - 1
		m(i+1) = ((2*i + 2) + 0.0)/(4 * (i + 1))
		m(i+1) = (m(i+1) * (2 * i + 1)) / (i + 1)
		m(i+1) = (m(i+1) * (2*i + 1) * X * X) / (2*i + 3)
	enddo
!$omp end parallel

	arcsin = X
	true_arcsin = asin(X)
	prev = X
	do i = 1, N_MAX
		tmp = prev * m(i)
		arcsin = arcsin + tmp
		if (true_arcsin - arcsin <= EPS) exit
		prev = tmp
	enddo

	print '(/, f8.5, 4x, a, /)', omp_get_wtime() - start_time, "секунд затрачено"
	print '(i8, 4x, a)', i, "слагаемых использовано"
	print 10, arcsin, "подсчитанный", true_arcsin, "истинный"
10	format (f12.8, 4x, a, /f12.8, 4x, a)
	deallocate(m)
end program
