! Перемножить две матрицы: C = A * B
! Контрольная №1, Кремер Илья | http://kremer.pro/blog/?post_type=post&p=35

program main
	implicit none
	include "omp_lib.h"

	integer i, j, k
	integer, parameter :: N = 1000 ! Меньшее значение в случае ошибки сегментации
	double precision, allocatable, dimension(:,:) :: a, b, c
	double precision rnd
	double precision start_time, elapsed

	allocate(a(N, N))
	allocate(b(N, N))
	allocate(c(N, N))

	call init_random_seed()
	do i = 1, N
		do j = 1, N
			call random_number(rnd)
			a(i, j) =  rnd * 100
			call random_number(rnd)
			b(i, j) =  rnd * 100
		enddo
	enddo
! Вывод матриц:
!	call print_matrix(a, N) ! Раскомментировать эту строчку для проверки корректности работы скорости
	print *
!	call print_matrix(b, N) ! Раскомментировать эту строчку для проверки корректности работы

	call omp_set_num_threads(8) ! 1, чтобы получить нераспараллелиную версию
	start_time = omp_get_wtime()
!$omp parallel do shared(a, b, c)
	do i = 1, N
		do j = 1, N
			c(i, j) = 0.0
			do k = 1, N
				c(i, j) = c(i, j) + a(i, k) * b(k, j)
			end do
		end do
	end do
	elapsed = omp_get_wtime() - start_time

	print *
! Вывод произведения матриц:
!	call print_matrix(c, N) ! Раскомментировать эту строчку для проверки корректности работы
	print '(a, 4x, f8.4, 4x, a)', "Времени затрачено:", elapsed, "секунд"
	deallocate(a, b, c)
end program

subroutine print_matrix(matrix, n)
	integer n
	double precision matrix(n, n)
	integer i, j

	do i = 1, n
		do j = 1, n
			write(*, '(e9.3, 4x)', advance = 'no'), matrix(i, j)
		enddo
		print '(/)'
	enddo
end subroutine

SUBROUTINE init_random_seed()
!!  Аналог srand(time(NULL))
	INTEGER :: i, n, clock
	INTEGER, DIMENSION(:), ALLOCATABLE :: seed

	CALL RANDOM_SEED(size = n)
	ALLOCATE(seed(n))

	CALL SYSTEM_CLOCK(COUNT = clock)

	seed = clock + 37 * (/ (i - 1, i = 1, n) /)
	CALL RANDOM_SEED(PUT = seed)

	DEALLOCATE(seed)
END SUBROUTINE
